var ENABLED = 1;
var DISABLED = 0;

var init_port = 21;

// 删除无效文件
var DeleteinvalidFun = function(shareName, path) {
  var cwh = getClientWH();
  var DeleteinvalidWindow = new MUI.Modal({
    id: 'DeleteinvalidWindow',
    title: UNAS._('Delete invalid Setting') + " " + shareName,
    modal: true,
    width: parseInt(cwh.w * 0.9),
    height: 250, //+50
    addClass: 'delete-modal',
    contentURL: '/apps/ftp/m/delete_invalidfolder.html?shareName=' + encodeURIComponent(shareName) + '&path=' + encodeURIComponent(path)
  });
  DeleteinvalidWindow.ProcessDeleteinvalidFolder = function() {
    errList();
  }
}
// 错误配置
function errList() {
  jQuery.ajax({
    url: "/apps/ftp/includes/index.php",
    type: "POST",
    async: true,
    dataType: 'json',
    contentType: "application/json;charset=utf-8",
    data: JSON.stringify({
      "cmd": "ftp_invalid_alload",
      "token": UToken
    }),
    success: function(data) {
      if (data.err == 0) {
        // 错误配置
        if (data.results.records.length > 0) {
          jQuery('#errorSettingList').html("");
          var folder_list = "";
          for (var k = 0; k < data.results.records.length; k++) {
            var folderarr = data.results.records[k];
            folder_list += '<dl>' +
              '<samp class="folder_samp1"></samp>' +
              '<h3><a>' + folderarr.shareName + '</a></h3>' +
              '<div>' +
              '<span>State:</span>' +
              '<span>Invalid Setting</span>' +
              '</div>' +
              '<p>' +
              '<a onclick="DeleteinvalidFun(' + "'" + folderarr.shareName + "','" + folderarr.path + "'" + ');">Delete</a>' +
              '</p>' +
              '</dl>';
          }
          jQuery('#errorSettingList').html(folder_list);

        } else {
          jQuery('#errorSettingList').html('Great, No Mistakes Found.');
          jQuery('#errorSettingList').show();
        }
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      jQuery('#ftp_setting_waiting_content').attr("style", "display:none");
      jQuery('#ftp_setting_waiting_logo').attr("style", "display:none");
    }
  });
}

function getFtpStatus() {
  jQuery('#ftp_setting_waiting_content').attr("style", "display:block");
  jQuery('#ftp_setting_waiting_logo').attr("style", "display:block");
  jQuery.ajax({
    url: "/apps/ftp/includes/index.php",
    type: "POST",
    async: true,
    dataType: 'json',
    contentType: "json",
    data: JSON.stringify({
      "cmd": "ftp_get_status",
      "token": UToken
    }),
    timeout: 30000,
    success: function(data) {
      //alert(JSON.stringify(data));
      if (data.err == 0) {}
      var status = data.results;
      if ((status.status == ENABLED) || jQuery('#enable_ftp').attr('checked')) {
        jQuery('#enable_ftp').prop('checked', true);
      } else {
        jQuery('#ftp_setting_page input').attr('disabled', true);
        jQuery('#enable_ftp').prop('checked', false);
        jQuery('#enable_ftp').attr('disabled', false);
      }
      if (status.protocol_ssl == ENABLED && status.protocol_standard == ENABLED) {
        jQuery('#ftpmode').prop('checked', false);
        jQuery('#ftpssl').prop('checked', true);
      } else if (status.protocol_ssl == ENABLED && status.protocol_standard == DISABLED) {
        jQuery('#ftpmode').prop('checked', true);
        jQuery('#ftpssl').prop('checked', true);
      } else if (status.protocol_ssl == DISABLED && status.protocol_standard == DISABLED) {
        jQuery('#ftpmode').prop('checked', true);
        jQuery('#ftpssl').prop('checked', false);
      } else {
        jQuery('#ftpmode').prop('checked', true);
        jQuery('#ftpssl').prop('checked', false);
      }
      if (status.anonymous == ENABLED) {
        jQuery('#anonymous').prop('checked', true);
      } else {
        jQuery('#anonymous').prop('checked', false);
      }
      jQuery('#ftpport').val(status.port);
      init_port = status.port;
      jQuery('#max_num').val(status.connection_max);
      jQuery('#per_num').val(status.connection_per_user);
      if (status.bw_up_max) {
        jQuery('#max_up_speed').val(status.bw_up_max);
      } else {
        jQuery('#max_up_speed').val('0');
      }
      if (status.bw_down_max) {
        jQuery('#max_down_speed').val(status.bw_down_max);
      } else {
        jQuery('#max_down_speed').val('0');
      }

      jQuery('#timeoutlogin').val(status.timeout_login);
      jQuery('#timeoutidle').val(status.timeout_idle);

      if (status.ports_range_default == ENABLED) {
        jQuery('#port_range_default').prop('checked', true);
        jQuery('#start_port').attr('disabled', true);
        jQuery('#end_port').attr('disabled', true);
      } else {
        jQuery('#port_range_set').prop('checked', true);
        jQuery('#start_port').val(status.ports_start);
        jQuery('#end_port').val(status.ports_end);
      }
      if (status.re_ext_ip == ENABLED) {
        jQuery('#re_ext_ip').prop('checked', true);
      } else {
        jQuery('#ext_ip').attr('disabled', true);
      }
      jQuery('#ext_ip').val(status.ext_ip);
      if (status.fxp == ENABLED) {
        jQuery('#fxp').prop('checked', true);
      } else {
        jQuery('#fxp').prop('checked', false);
      }
      jQuery('#ftp_setting_waiting_content').attr("style", "display:none");
      jQuery('#ftp_setting_waiting_logo').attr("style", "display:none");
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
      jQuery('#ftp_setting_waiting_content').attr("style", "display:none");
      jQuery('#ftp_setting_waiting_logo').attr("style", "display:none");
    }
  });
}

function edit_change() {
  var subm = true;

  jQuery('label[class="ftp_form_left_info"]').each(function() {
    if (jQuery(this).html() != '') {
      jQuery('#ftp_setting_apply').attr('class', 'unas_button_disabled');
      subm = false;
    }
  });
  if (subm) {
    jQuery('#ftp_setting_apply').attr('class', 'unas_button');
  }
}

function ftpApply() {
  if (jQuery("#ftp_setting_apply").attr("class") == "unas_button_disabled")
    return false;
  jQuery('#ftp_setting_waiting_content').attr("style", "display:block");
  jQuery('#ftp_setting_waiting_logo').attr("style", "display:block");
  var data = {
    "status": jQuery('#enable_ftp').prop('checked') ? ENABLED : DISABLED,
    "protocol_standard": jQuery('#ftpmode').prop('checked') ? ENABLED : DISABLED,
    "protocol_ssl": jQuery('#ftpssl').prop('checked') ? ENABLED : DISABLED,
    "port": Number(jQuery('#ftpport').val()),
    "anonymous": jQuery('#anonymous').prop('checked') ? ENABLED : DISABLED,
    "timeout_login": Number(jQuery('#timeoutlogin').val()),
    "timeout_idle": Number(jQuery('#timeoutidle').val()),
    "connection_max": Number(jQuery('#max_num').val()),
    "connection_per_user": Number(jQuery('#per_num').val()),
    "bw_up_max": Number(jQuery('#max_up_speed').val()),
    "bw_down_max": Number(jQuery('#max_down_speed').val()),
    "ports_range_default": jQuery('#port_range_default').prop('checked') ? ENABLED : DISABLED,
    "ports_start": jQuery('#port_range_default').prop('checked') ? 55536 : Number(jQuery('#start_port').val()),
    "ports_end": jQuery('#port_range_default').prop('checked') ? 55536 : Number(jQuery('#end_port').val()),
    "re_ext_ip": jQuery('#re_ext_ip').prop('checked') ? ENABLED : DISABLED,
    "ext_ip": jQuery('#ext_ip').val(),
    "fxp": jQuery('#fxp').prop('checked') ? ENABLED : DISABLED
  };
  var send_data = {
    "cmd": "ftp_setting",
    "token": UToken,
    "params": data
  }
  jQuery.ajax({
    url: "/apps/ftp/includes/index.php",
    type: "POST",
    async: true,
    dataType: 'json',
    contentType: "json",
    data: JSON.stringify(send_data),
    timeout: 30000,
    success: function(result) {
      getFtpStatus();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
      jQuery('#ftp_setting_waiting_content').attr("style", "display:none");
      jQuery('#ftp_setting_waiting_logo').attr("style", "display:none");
    }
  });
}
// 限制输入数字最大值
function upperLimit(obj, ceiling) {
  jQuery(obj).val(jQuery(obj).val().replace(/\D+/g, ''));
  if (jQuery(obj).val() > ceiling) {
    jQuery(obj).val(ceiling);
  }
}

function getftpversion() {
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    dataType: 'json',
    contentType: "application/json;charset=utf-8",
    data: JSON.stringify({
      "cmd": "ftp_version",
      "token": UToken
    }),
    success: function(res) {
      if (res.err == 0) {
        jQuery('#jv-ftp-v').text(res.results.version);
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

(function() {
  getFtpStatus();
  errList();
  getftpversion();
  jQuery('div[infotableid]').click(function() {
    var id = jQuery(this).attr('infotableid');
    if (id == "ftp_err_handling") {
      jQuery("#jv-unas_footer").hide();
    } else {
      jQuery("#jv-unas_footer").show();
    }
    jQuery('#ftp_general_setting_tab').attr('class', 'unas_tab');
    jQuery('#ftp_connect_setting_tab').attr('class', 'unas_tab');
    jQuery('#ftp_advanced_setting_tab').attr('class', 'unas_tab');
    jQuery('#ftp_err_handling_tab').attr('class', 'unas_tab');
    jQuery(this).attr('class', 'unas_tab_sel');

    jQuery('#ftp_general_setting').attr('style', 'display:none;');
    jQuery('#ftp_connect_setting').attr('style', 'display:none;');
    jQuery('#ftp_advanced_setting').attr('style', 'display:none;');
    jQuery('#ftp_err_handling').attr('style', 'display:none;');
    jQuery('#' + id).attr('style', 'display:block;');
  });
  jQuery('#enable_ftp').click(function() {
    if (jQuery('#enable_ftp').prop('checked') == false) {
      jQuery('#ftp_setting_page input').attr('disabled', true);
      jQuery('#enable_ftp').attr('disabled', false);
    }
    if (jQuery('#enable_ftp').prop('checked') == true) {
      jQuery('#ftp_setting_page input').attr('disabled', false);
      jQuery('#enable_ftp').attr('disabled', false);
    }
  });
  jQuery('#ftpmode').click(function() {
    if (!jQuery('#ftpmode').prop('checked') && !jQuery('#ftpssl').prop('checked')) {
      jQuery('#modeinfo').html(UNAS._('*Please choose an FTP protocol'));
      edit_change();
    } else {
      jQuery('#modeinfo').html('');
      edit_change();
    }
    edit_change();
  });
  jQuery('#ftpssl').click(function() {
    if (!jQuery('#ftpmode').prop('checked') && !jQuery('#ftpssl').prop('checked')) {
      jQuery('#modeinfo').html(UNAS._('*Please choose an FTP protocol'));
      edit_change();
    } else {
      jQuery('#modeinfo').html('');
      edit_change();
    }
  });

  jQuery('#ftpport').keyup(function() {
    reg = new RegExp('^[0-9]{1,}$');
    var port = jQuery('#ftpport').val();
    if (port == init_port) {
      jQuery('#portinfo').html('');
      edit_change();
    } else
    if (reg.exec(port)) {
      if ((reg.exec(port) > 65535) || (reg.exec(port) < 1)) {
        jQuery('#portinfo').html(UNAS._('*Port must be 1~65535'));
        edit_change();
      } else if (reg.exec(port) < 65536) {
        jQuery.ajax({
          url: "/apps/ftp/includes/index.php",
          type: "POST",
          async: true,
          dataType: 'json',
          contentType: "json",
          data: JSON.stringify({
            "cmd": "ftp_checkport",
            "token": UToken,
            "params": {
              "port": Number(port)
            }
          }),
          timeout: 30000,
          success: function(data) {
            if (data.err != 0) {
              jQuery('#portinfo').html(UNAS._('*Port has been used'));
              edit_change();
            } else if (jQuery('#portinfo').html() != '') {
              if (jQuery('#ftpport').val() < 65535) {
                jQuery('#portinfo').html('');
                edit_change();
              }
            }
          }
        });
      }
    } else {
      jQuery('#portinfo').html(UNAS._('*Port must be 1~65535'));
      edit_change();
    }
  });
  jQuery('#timeoutlogin').keyup(function() {
    reg = new RegExp('^[0-9]{1,}$');
    var timeoutlogin = jQuery('#timeoutlogin').val();
    if (reg.exec(timeoutlogin)) {
      jQuery('#timeoutlogininfo').html('');
    } else {
      jQuery('#timeoutlogininfo').html(UNAS._('*must be a number'));
    }
    edit_change();
  });
  jQuery('#timeoutidle').keyup(function() {
    reg = new RegExp('^[0-9]{1,}$');
    var timeoutidle = jQuery('#timeoutidle').val();
    if (reg.exec(timeoutidle)) {
      jQuery('#timeoutidleinfo').html('');
    } else {
      jQuery('#timeoutidleinfo').html(UNAS._('*must be a number'));
    }
    edit_change();
  });
  jQuery('#max_num').keyup(function() {
    reg = new RegExp('^[0-9]{1,}$');
    var max_num = jQuery('#max_num').val();
    var per_num = jQuery('#per_num').val();
    if (reg.exec(max_num)) {
      if (reg.exec(max_num) < Number(per_num)) {
        jQuery('#maxnuminfo').html(UNAS._('*Total connections must be greater than per'));
        edit_change();
      } else {
        jQuery('#maxnuminfo').html('');
        edit_change();
      }
    } else {
      jQuery('#maxnuminfo').html(UNAS._('*must be a number'));
      edit_change();
    }
  });
  jQuery('#per_num').keyup(function() {
    reg = new RegExp('^[0-9]{1,}$');
    var max_num = jQuery('#max_num').val();
    var per_num = jQuery('#per_num').val();
    if (reg.exec(per_num)) {
      if (Number(max_num) < reg.exec(per_num)) {
        jQuery('#maxnuminfo').html(UNAS._('*Total connections must be greater than per'));
        edit_change();
      } else {
        jQuery('#pernuminfo').html('');
        edit_change();
      }
    } else {
      jQuery('#pernuminfo').html(UNAS._('*must be a number'));
      edit_change();
    }
  });

  jQuery('#max_up_speed').keyup(function() {
    reg = new RegExp('^[0-9]{1,}$');
    max_up_speed = jQuery('#max_up_speed').val();
    if (reg.exec(max_up_speed)) {
      jQuery('#upinfo').html('');
    } else {
      jQuery('#upinfo').html(UNAS._('*must be a number'));
    }
    edit_change();
  });
  jQuery('#max_down_speed').keyup(function() {
    reg = new RegExp('^[0-9]{1,}$');
    max_down_speed = jQuery('#max_down_speed').val();
    if (reg.exec(max_down_speed)) {
      jQuery('#downinfo').html('');
    } else {
      jQuery('#downinfo').html(UNAS._('*must be a number'));
    }
    edit_change();
  });
  jQuery('#port_range_default').click(function() {
    if (jQuery('#port_range_default').prop('checked')) {
      jQuery('#start_port').attr('disabled', true);
      jQuery('#end_port').attr('disabled', true);

      jQuery('#startportinfo').html('');
      jQuery('#endportinfo').html('');
      edit_change();
    }
  });
  jQuery('#port_range_set').click(function() {
    if (jQuery('#port_range_set').prop('checked')) {
      jQuery('#start_port').attr('disabled', false);
      jQuery('#end_port').attr('disabled', false);
      if (jQuery('#start_port').val() == '') {
        jQuery('#startportinfo').html(UNAS._('*cannot be empty'));
        edit_change();
      }
      if (jQuery('#end_port').val() == '') {
        jQuery('#endportinfo').html(UNAS._('*cannot be empty'));
        edit_change();
      }
    }
  });
  jQuery('#start_port').keyup(function() {
    reg = new RegExp('^[0-9]{1,}$');
    start_port = jQuery('#start_port').val();
    end_port = jQuery('#end_port').val();
    if (!(reg.exec(start_port)) || !(reg.exec(end_port))) {
      jQuery('#startstopportinfo').html(UNAS._('*cannot be empty'));
    } else {
      jQuery('#startstopportinfo').html('');
    }
    edit_change();
  });
  jQuery('#end_port').keyup(function() {
    reg = new RegExp('^[0-9]{1,}$');
    start_port = jQuery('#start_port').val();
    end_port = jQuery('#end_port').val();
    if (!(reg.exec(start_port)) || !(reg.exec(end_port))) {
      jQuery('#startstopportinfo').html(UNAS._('*cannot be empty'));
    } else {
      jQuery('#startstopportinfo').html('');
    }
    edit_change();
  });
  jQuery('#re_ext_ip').click(function() {
    if (jQuery('#re_ext_ip').prop('checked')) {
      jQuery('#ext_ip').attr('disabled', false);
    } else {
      jQuery('#ext_ip').attr('disabled', true);
    }
    edit_change();
  });
  jQuery('#fxp').click(function() {
    edit_change();
  });
})();
